{.pl71}
{$c-}
program fraktale;

const  xsize =  384   ; ysize = 288    ;
       s     = 1000   ;
       cx    =  -0.15 ; cy    =  0.73  ;
       xstart : integer = 0 ;
       ystart : integer = 0 ;
       kmax   : integer = 100 ;
       xmin   : real = -1.25 ;
       ymin   : real = -1 ;
       xmax   : real =  1.25 ;
       ymax   : real =  1 ;

var
  Datei       :file ;                       (* fuer Bild speichern *)
  fname       :string[8] ;
  ja_nein     :char ;
  Zaehler,bi  :integer ;
  buffer      :array [0..127] of byte ;
  buf1        :array [0..21] of real ;
  buf2        :array [0..63] of integer ;

                                           (* fuer fraktal       *)
  i , x, xx,xx_2,yy_3, y, yy , A , C , Z ,  k   : integer ;
  dx , dy , r , qx , qy , x0 ,x1 , y0 , y1 : real ;
  qx_1, qy_1, x1_1, y1_1                   : real ;
  qx_2, qy_2, x1_2, y1_2                   : real ;
  qx_3, qy_3, x1_3, y1_3                   : real ;
  color                                    : byte ;
  eing                                     : char ;


{$I UPVIS3MH.PAS }

procedure Flash_ein ;
begin
  inline
  ($3E / $0F /
   $D3 / $B0 /
   $3E / $06 /
   $D3 / $B1 )
end;

procedure Flash_aus ;
begin
  inline
  ($3E / $0F /
   $D3 / $B0 /
   $3E / $16 /
   $D3 / $B1 )
end;

procedure DMA_vorbereiten ;
begin
 flash_ein ;
 viscu(0,287) ;
 inline
 ($3E / $F0 / (* init:  ld   a,0f0h                                   *)
  $D3 / $B2 / (*        out  (visfarb),a  ;alle Farbebenen aktiv      *)
  $3E / $4A / (*        ld   a,4ah        ;Kommando MASK              *)
  $D3 / $B0 / (*        out  (viscom),a                               *)
  $3E / $FF / (*        ld   a,0ffh       ;alle Bit auf 1             *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $4C / (*        ld   a,4ch        ;Kommando FIGS              *)
  $D3 / $B0 / (*        out  (viscom),a                               *)
  $3E / $02 / (*        ld   a,2          ;Richtung                   *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $1F / (*        ld   a,low(zeilen-1) ;Zeilenzahl              *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $01 / (*        ld   a,high(zeilen-1)                         *)
  $D3 / $B1 ) (*        out  (visdat),a                               *)
end ;


procedure DMA_lesen_ein ;
begin
 inline
 ($3E / $BE / (* read:  ld   a,low(spalt-2) ;Spaltenzahl              *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $00 / (*        ld   a,high(spalt-2)                          *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $5F / (*        ld   a,low((spalt-2)/2)                       *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $00 / (*        ld   a,high((spalt-2)/2)                      *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $A4 / (*        ld   a,0a4h       ;DMA-Lesen Start            *)
  $D3 / $B0 ) (*        out  (viscom),a                               *)
end;

procedure DMA_lesen ;
begin
 inline
 ($F3 /       (*        di                                            *)
  $06 / $80 / (*        ld   b,128        ;Anzahl der zu uebergebenden Bytes*)
  $0E / $B1 / (*        ld   c,visdat     ;Port-Adresse               *)
  $21 / buffer / (*     ld   hl,buffer    ;Zwischenspeicher           *)
  $E5 /       (*rdloop: push hl                                       *)
  $2A / zaehler / (*    ld   hl,(zaehler) ;Zaehler der Gesamtanzahl   *)
  $2B /       (*        dec  hl                                       *)
  $22 / zaehler / (*    ld   (zaehler),hl                             *)
  $23 /       (*        inc  hl                                       *)
  $7C /       (*        ld   a,h          ;Test auf 0                 *)
  $B5 /       (*        or   l                                        *)
  $E1 /       (*        pop  hl                                       *)
  $28 / $18 / (*        jr   z,rdend      ;Rueckkehr zum Hauptprogramm*)
  $DB / $B1 / (* rd0:   in   a,(visdat)   ;Status lesen               *)
  $E6 / $40 / (*        and  40h          ;Zeilenruecklauf ?          *)
  $28 / $FA / (*        jr   z,rd0        ;wenn nicht, dann nochmal   *)
  $DB / $B6 / (* rd1:   in   a,(visdreq)  ;Test auf DMA-Request       *)
  $E6 / $01 / (*        and  1                                        *)
  $20 / $FA / (*        jr   nz,rd1                                   *)
  $3E / $90 / (*        ld   a,90h        ;fuer Ausgabe von DACK      *)
  $D3 / $B4 / (*        out  (visdack),a                              *)
  $ED / $A2 / (*        ini               ;Eingabe eines Byte von der VIS*)
  $3E / $80 / (*        ld   a,80h        ;Ausschalten von DACK       *)
  $D3 / $B4 / (*        out  (visdack),a                              *)
  $20 / $DA / (*        jr   nz,rdloop                                *)
  $FB )       (* rdend: ei                ;ENDE des Lesens            *)
end ;

procedure DMA_schreiben_ein ;
begin
 inline
 ($3E / $BF / (* write: ld   a,low(spalt-1);Spaltenzahl               *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $00 / (*        ld   a,high(spalt-1)                          *)
  $D3 / $B1 / (*        out  (visdat),a                               *)
  $3E / $24 / (*        ld   a,24h        ;DMA-Schreiben Start        *)
  $D3 / $B0 ) (*        out  (viscom),a                               *)
end ;

procedure DMA_schreiben ;
begin
 inline
 ($F3 /       (*        di                                            *)
  $06 / $80 / (*        ld   b,128        ;Anzahl der zu uebergebenden Bytes*)
  $0E / $B1 / (*        ld   c,visdat     ;Port-Adresse               *)
  $21 / buffer / (*     ld   hl,buffer    ;Zwischenspeicher           *)
  $E5 /       (* wrloop:push hl                                       *)
  $2A / zaehler / (*    ld   hl,(zaehler) ;Zaehler der Gesamtanzahl   *)
  $2B /       (*        dec  hl                                       *)
  $22 / zaehler / (*    ld   (zaehler),hl                             *)
  $23 /       (*        inc  hl                                       *)
  $7C /       (*        ld   a,h          ;Test auf 0                 *)
  $B5 /       (*        or   l                                        *)
  $E1 /       (*        pop  hl                                       *)
  $28 / $18 / (*        jr   z,wrend      ;Rueckkehr zum Hauptprogramm*)
  $DB / $B1 / (* wr0:   in   a,(visdat)   ;Status lesen               *)
  $E6 / $40 / (*        and  40h          ;Zeilenruecklauf ?          *)
  $28 / $FA / (*        jr   z,wr0        ;wenn nicht, dann nochmal   *)
  $DB / $B6 / (* wr1:   in   a,(visdreq)  ;Test auf DMA-Request       *)
  $E6 / $01 / (*        and  1                                        *)
  $20 / $FA / (*        jr   nz,wr1                                   *)
  $3E / $90 / (*        ld   a,90h        ;fuer Ausgabe von DACK      *)
  $D3 / $B4 / (*        out  (visdack),a                              *)
  $ED / $A3 / (*        outi              ;Ausgabe eines Byte an die VIS*)
  $3E / $80 / (*        ld    a,80h       ;Ausschalten von DACK       *)
  $D3 / $B4 / (*        out   (visdack),a                             *)
  $20 / $DA / (*        jr    nz,wrloop                               *)
  $FB )       (* wrend: ei                ;ENDE                       *)
end ;

procedure Datei_schreiben ;
begin
  clrscr;
  gotoxy(40,23);
  write('Bitte warten, VIS 3 wird gelesen !');
  rewrite(Datei) ;
  blockwrite(Datei,buf1,1) ;
  blockwrite(Datei,buf2,1) ;
  zaehler := 192*288 ;
  DMA_vorbereiten ;
  DMA_lesen_ein ;
  repeat
    DMA_lesen ;
    blockwrite(Datei,buffer,1) ;
  until zaehler = 0 ;
  close(Datei) ;
  flash_aus ;
end ;

procedure Datei_lesen ;
begin
  clrscr ;
  gotoxy(40,23) ;
  write('Bitte warten, Datei wird gelesen !') ;
  reset(Datei) ;
  blockread(Datei,buf1,1) ;
  blockread(Datei,buf2,1) ;
  zaehler := 192*288 ;
  DMA_vorbereiten ;
  DMA_schreiben_ein ;
  repeat
    blockread(Datei,buffer,1) ;
    DMA_schreiben ;
  until zaehler = 0 ;
  close(Datei) ;
  flash_aus ;
end;


procedure step1;
begin
  dx := (xmax-xmin)/(xsize-1) ;
  dy := (ymax-ymin)/(ysize-1) ;
end ;

procedure step2;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx := 0 ; qy := 0 ;
end ;

procedure step2_1;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_1 := 0 ; qy_1 := 0 ;
end ;

procedure step2_2;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_2 := 0 ; qy_2 := 0 ;
end ;

procedure step2_3;
begin
  x0 := xmin + x * dx ;
  y0 := ymin + y * dy ;
  k  := 0 ; qx_3 := 0 ; qy_3 := 0 ;
end ;

procedure step3;
begin
  qx := sqr(x0) ; qy := sqr(y0) ;
  y1 := qy - qx -cy ;
  x1 := 2 * x0 * y0 - cx ;
  x0 := x1 ; y0 := y1 ;
  k  := k + 1
end ;

procedure step3_1;
begin
  qx_1 := sqr(x0) ; qy_1 := sqr(y0) ;
  y1_1 := qy_1 - qx_1*qx_1 -cy ;
  x1_1 := 2 * x0 * y0 - cx ;
  x0 := x1_1 ; y0 := y1_1 ;
  k  := k + 1
end ;

procedure step3_2;
begin
  qx_2 := sqr(x0) ; qy_2 := sqr(y0) ;
  y1_2 := qy_2 - qx_2 -cy ;
  x1_2 := 2 * (x0/sqr(x0)) * y0 - cx ;
  x0 := x1_2 ; y0 := y1_2 ;
  k  := k + 1
end ;

procedure step3_3;
begin
  qx_3 := sqr(x0) ; qy_3 := sqr(y0) ;
  y1_3 := qy_3*qy_3 - qx_3 -cy ;
  x1_3 := 2 * x0 * y0 - cx ;
  x0 := x1_3 ; y0 := y1_3 ;
  k  := k + 1
end ;

procedure step4 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    vispa(color,x,y)
  end
end;

procedure step4_1 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    xx:=x+192; yy:=y+144;
    vispa(color,xx,yy)
  end
end;

procedure step4_2 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    xx_2:=x+192;
    vispa(color,xx_2,y)
  end
end;

procedure step4_3 ;
begin
  if k < kmax then begin
    color := k mod 14 + 1 ;
    yy_3:=y+144;
    vispa(color,x,yy_3)
  end
end;

procedure Algorithmus ;
label exit ;
begin
  gotoxy(1,20) ;
  writeln('Die Berechnung kann mit jeder Taste abgebrochen werden !                                       ') ;
  step1 ;
  for y := ystart to ysize  do begin
    gotoxy(1,15) ;
    write('Bildzeile: ',y) ;
    for x := xstart to xsize  do begin
      step2 ;
      while (qx + qy < s ) and ( k < kmax ) do  step3 ;
      step4 ;
      if keypressed then goto exit
    end ;
    xstart := 0
  end ;
exit : end ;


procedure Hauptmenue ;
begin
  clrscr ;
    writeln('Fraktale auf der VIS 3 ( in 16 Farben )') ;
    writeln('nach Mandelbrot') ;
    gotoxy(1,10) ;
    writeln('Berechnung eines neuen Bildes...........1') ;
    writeln ;
    writeln('Laden eines Bildes von der Diskette.....2') ;
    writeln ;
    writeln('Anzeige der Parameter...................3') ;
    writeln ;
    writeln('Programmende............................0') ;
    gotoxy(1,20) ;
    write('Eingabe der gewuenschten Funktion :') ;
    repeat ;
      read(kbd,eing) ;
    until eing in ['0'..'3']
end ;


procedure Parameter ;
begin
    clrscr ;
    writeln('Parameter des Bildes :') ;
    writeln;
    writeln('X min  = ',xmin:5:2);
    writeln('X max  = ',xmax:5:2);
    writeln('Y min  = ',ymin:5:2);
    writeln('Y max  = ',ymax:5:2);
    writeln('Tiefe  = ',kmax:5);
    gotoxy(1,23) ;
    writeln('(c) 1986  HELLOT-SOFT');
    gotoxy(65,23) ;
end;

procedure besetzen;
begin
  Parameter ;
  gotoxy(1,12) ;
  write('Neue Werte (j/n) ?') ;
  repeat
    read(kbd,ja_nein) ;
  until ja_nein in ['j','n','N','J'] ;
  if ja_nein in ['j','J'] then begin
        writeln ;
        write('X min =') ;
        readln(xmin) ;
        write('X max =') ;
        readln(xmax) ;
        write('Y min =') ;
        readln(ymin) ;
        write('Y max =') ;
        readln(ymax) ;
        write('Tiefe =') ;
        readln(kmax)
      end ;
  xstart := 0 ;
  ystart := 0
end;

procedure Dateiname ;
begin
  clrscr ;
  gotoxy(1,20) ;
  write('Name der Datei (ohne Ext.) :') ;
  gotoxy(30,20) ;
  readln(fname) ;
  assign(Datei,concat(Fname,'.FRA'))
end ;

procedure Bild_lesen ;
begin
  Dateiname ;
  Datei_lesen ;
  xmin := buf1[0] ;
  xmax := buf1[1] ;
  ymin := buf1[2] ;
  ymax := buf1[3] ;
  kmax := buf2[0] ;
  xstart:=buf2[1] ;
  ystart:=buf2[2]
end ;

procedure Bild ;
begin
  parameter ;
  if xstart + ystart = 0 then visbl ;
  if (ystart <= ysize) and (xstart < xsize) then
  begin
    Algorithmus ;
    clrscr ;
    gotoxy(1,10) ;
    write('Soll das aktuelle Bild abgespeichert werden (j/n) ?') ;
    repeat
      read(kbd,ja_nein) ;
    until ja_nein in ['J','N','n','j'] ;
    if ja_nein in ['j','J'] then begin
      Dateiname ;
      buf1[0] := xmin ;
      buf1[1] := xmax ;
      buf1[2] := ymin ;
      buf1[3] := ymax ;
      buf2[0] := kmax ;
      buf2[1] := x ;
      buf2[2] := y ;
      Datei_schreiben
    end
  end
end ;


(*  Haupt-Prozedur  *)
begin
  visin ;
  flash_ein ;
  visbl ;
  repeat
      Hauptmenue ;
      clrscr ;
      if eing = '1' then besetzen ;
      if eing = '2' then Bild_lesen ;
      if (eing='1')or(eing='2') then Bild ;
      if eing = '3' then besetzen ;
  until eing = '0'
end.